#ifndef DIM
#error DIM unset
#endif

#include <dune/common/fmatrix.hh>
#include <dune/common/fvector.hh>
#include <dune/grid/alugrid.hh>
#include <dune/istl/bcrsmatrix.hh>
#include <dune/istl/bvector.hh>

#include <dune/tectonic/myblockproblem.hh>
#include <dune/tectonic/myconvexproblem.hh>

using SmallVector = Dune::FieldVector<double, DIM>;
using SmallMatrix = Dune::FieldMatrix<double, DIM, DIM>;
using VectorType = Dune::BlockVector<SmallVector>;
using MatrixType = Dune::BCRSMatrix<SmallMatrix>;

using GridType = Dune::ALUGrid<DIM, DIM, Dune::simplex, Dune::nonconforming>;

template class MySolver<DIM, MatrixType, VectorType, GridType>;
